#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "main.h"



// 16bit^C}[rv荞ݏ 
ISR ( TIMER1_COMPA_vect )
{
	// JE^Z
	disp_chg++;
	disp_off++;
	countin++;
	ilmi_chk++;

	// ԑpXJEg
	if(countin >= COUNTER_TIME){
		countin = 0;
		isr_spplus_count();
	}

	// C~l[V`FbN
	if(ilmi_chk >= ILUMI_TIME){
		ilmi_chk = 0;
		isr_ilum_chk();
	}

	// XV^C~O	
	if(disp_chg >= CHG_TIME){
		disp_chg = 0;
		disp_off = 0;
		isr_disp_chg();
	}

	// DISP_OFFԂɂȂA͐ݒ莞Ԃ0̏ꍇ
	if((disp_off >= OFF_TIME) || (OFF_TIME == 0)){
		isr_disp_segment();
	}
}

// fBXvC\
static void isr_disp_segment()
{
	// \ύXꂽꍇ̂ݏs
	if(disp_point_bef != disp_point){
		disp_point_bef = disp_point;

		// w茅̕\o
		display_segment(disp_point, speed_value[disp_point]);
	}
}

// ύX
static void isr_disp_chg()
{
	// XV
	disp_point++;

	if(disp_point >= DISP_DIGIT){
		disp_point = 0;
	}

	// ؂ւ̏ꍇ͕\NA
	display_clear();
}

// ԑpXJEg
static void isr_spplus_count()
{
	uint8_t speed = 0;

	// pXJEg擾
	mesdata[mespos] = TCNT0;

	// 8bitJE^̃JEgipXj
	TCNT0 = 0;

	mespos++;
	if(mespos == MES_COUNT){
		mespos = 0;
	}

	// Xs[hvZiMES_COUNT񕪂1.4bԂ̈ړρj
	for(uint8_t i = 0; i < MES_COUNT; i++){
		speed += mesdata[(int)i];
	}

	// eɒl𕪗
	calc_speed(speed);
}

// C~l[V`FbN
static void isr_ilum_chk()
{
	if(hud_on == HUD_FLG_ON){	// HUDo[W̏ꍇ
		// D5̏Ԃ`FbNiC~ԁj
		if((PIND & _BV(PIND5)) == 0){
			// C~Ȉꍇ̕\
			CHG_TIME = DISPLAY_CHG_TIME_ILUM_HUD;
			OFF_TIME = DISPLAY_OFF_TIME_ILUM_HUD;
		} else {
			// C~It̏ꍇ̕\
			CHG_TIME = DISPLAY_CHG_TIME_HUD;
			OFF_TIME = DISPLAY_OFF_TIME_HUD;
		}
	} else {
		// D5̏Ԃ`FbNiC~ԁj
		if((PIND & _BV(PIND5)) == 0){
			// C~Ȉꍇ̕\
			CHG_TIME = DISPLAY_CHG_TIME_ILUM;
			OFF_TIME = DISPLAY_OFF_TIME_ILUM;
		} else {
			// C~It̏ꍇ̕\
			CHG_TIME = DISPLAY_CHG_TIME;
			OFF_TIME = DISPLAY_OFF_TIME;
		}
	}
}



/////////////////////////////////
// ^C}[
/////////////////////////////////
static void timer_init()
{
	// ^C}[ݒ
	// 8bit^C}[T0s̗ŃJEg
	TCCR0B = _BV(CS02) | _BV(CS01);


	// 16bit^C}[vXP[[ȂŃJEg
	// rAŊ荞
	// CTCi荞݂ƃJE^Zbgj
	TCCR1B = _BV(CS10) | _BV(WGM12);

	// 16bit^C}[̍őlݒi1ms or 100us̐ݒj
	OCR1A = TIMER_OVF_COUNT;

	// 16bit^C}[̔rA
	TIMSK = _BV(OCIE1A);
}

/////////////////////////////////
// |[g
/////////////////////////////////
static void port_init()
{

	// EHb`hbN^C}[~
	WDTCSR = 0;


	// |[g̏ݒ

	// vAbv֎~
	MCUCR |= _BV(PUD);

	// AiOr@~
	ACSR &= _BV(ACD);

	// B0`B7܂ło͂(7segp)
    PORTB = 0;
    DDRB  = 0b11111111;

	// D4́EvAbvݒ(pX͗p)
	// D5́EvAbv(C~͗p C~ONGNDɗ)
	// D0,D1,D2óigWX^pj
  	// D6́EvAbvݒiHUDݒ̓ǂݍݗpj
	// D7͖gpȂ̂Őݒ肵Ȃ
	PORTD = 0;
    DDRD  = 0b00001111;
    PORTD = 0b01110000;

	// vAbv
	MCUCR &= ~_BV(PUD);

	// ҂D6̏ԂmF
	wait(HUD_TIME);
	if((PIND & _BV(PIND6)) == 0){
		// ڑ(GNDɗ)̏ꍇHUD[h
		hud_on = HUD_FLG_ON;
	} else {
		// ڑ(HI)̏ꍇ͒ʏ탂[h
		hud_on = HUD_FLG_OFF;
	}

	// vAbv֎~
	MCUCR |= _BV(PUD);

	// `FbNID6[q͌ɖ߂(rHUD[hύXȂ)
	// ɏo͐ݒ(PORTD)Lɂ邱ƁAȂƏo͂ɐݒ莞Ho͂Z̉\
	PORTD &= ~_BV(PIND6);
	DDRD  |= _BV(PIND6);

	// vAbv
	MCUCR &= ~_BV(PUD);

}



///////////////////
// 7segɕ\
///////////////////
static void display_segment(uint8_t p_cPoint, uint8_t disp_num)
{
	uint8_t value = 0;

	// \Ώۂ̒l̏ꍇ
	if(disp_num == DISP_VALUE_NULL){
		// Ȃ
		return;
	}

	if(hud_on == HUD_FLG_ON){
		// HUD[h̏ꍇ
		value = pgm_read_byte(&seg_num_b[disp_num]);
	} else {
		// ʏ탂[h̏ꍇ
		value = pgm_read_byte(&seg_num[disp_num]);
	}

	// ɍ킹o
	PORTB = value;

	if(p_cPoint == 0){
		// 100̈
		PORTD |= SEG100;
	} else if(p_cPoint == 1){
		// 10̈
		PORTD |= SEG010;
	} else if(p_cPoint == 2){
		// 1̈
		PORTD |= SEG001;
	} else {
		PORTD &= ~(_BV(PIND0) | _BV(PIND1) | _BV(PIND2));
	}
}

//////////////////
// S\NA
//////////////////
static void display_clear()
{
	// SLEDo͂OFF܂
	PORTB = 0;

	// egWX^̏o͂OFF
	PORTD &= ~(_BV(PIND0) | _BV(PIND1) | _BV(PIND2));
}

//////////////////
// _`FbN
//////////////////
static void initial_check()
{
	display_clear();

	display_segment(2, 8);
	wait(INITIAL_ON_TIME);

	display_clear();

	display_segment(1, 8);
	wait(INITIAL_ON_TIME);

	display_clear();

	display_segment(0, 8);
	wait(INITIAL_ON_TIME);

	display_clear();

	// 0\Ƃ
	speed_value[0] = DISP_VALUE_NULL;
	speed_value[1] = DISP_VALUE_NULL;
	speed_value[2] = 0;

	wait(INITIAL_OFF_TIME);
}

//////////////////
// Xs[hvZ
//////////////////
static void calc_speed(uint8_t p_speed)
{
	uint8_t speed = p_speed;
	uint8_t tmp2 = 0;

	uint8_t find = 0;
	uint8_t tmp = 0;
	const uint8_t kurai[] = {100, 10, 1};

	// e̐l擾
	for(tmp2 = 0; tmp2 < DISP_DIGIT; tmp2++){
		tmp = 0;
		for(;;){
			if(speed < kurai[tmp2]){
				break;
			}
			tmp++;
			speed -= kurai[tmp2];
			find = 1;
		}
		
		if(find == 0){
			if(tmp2 == 2){
				// 1̈ʂ̏ꍇ0ł\
				speed_value[tmp2] = tmp;
			} else{
				// ʌ0̏ꍇ͕\Ȃ
				speed_value[tmp2] = DISP_VALUE_NULL;
			}
		} else {
			// Y̐lێ
			speed_value[tmp2] = tmp;
		}
	}
}

/////////////////////
// ҂ 1msP
/////////////////////
static void wait(uint16_t time)
{
	for(uint16_t i = 0; i < time; i++){
		_delay_ms(1);
	}
}

/////////////////////////////
// C֐
/////////////////////////////
int main(void)
{
	// 荞݋֎~
	cli();

	disp_chg = 0;
	disp_off = 0;
	countin = 0;
	disp_point = 0;
	disp_point_bef = 0;
	hud_on = 0;
	ilmi_chk = 0;
	CHG_TIME = DISPLAY_CHG_TIME;
	OFF_TIME = DISPLAY_OFF_TIME;

	// pXf[^
	for(mespos = 0; mespos < MES_COUNT; mespos++){
		mesdata[mespos] = 0;
	}

	mespos = 0;

	// |[gݒ菉
	port_init();

	// _`FbN
	initial_check();

	// ^C}[
	timer_init();

	// S荞݋
	sei();

	// I҂i҂j
	for(;;){}

	return 0;
}
